// ------------------------------------------------------------
//   Site Builder (c) 2004, SwSoft
//
//
//   since: 16 Oct 2004
// version: $Id: pagesets.js,v 1.1.1.1 2006/07/21 09:13:59 yguskov Exp $
//  author: Ilnar Salachiev
// ------------------------------------------------------------

// consts
var PAGE_VIEW_MODE = 0;
var PAGE_ADD_MODE = 1;
var PAGE_EDIT_MODE = 2;

var inputNewPageBoxID = 'SB_Style_inputNewPage';
var selectBoxName = 'sb_pages_list';
var inputPageTitle = 'sb_page_title';
var inputPageContent = 'sb_page_content';
var inputPageSetTitle = 'sb_pageset_title';
var pageInfoButtonsPanelID = 'SB_Style_pageInfoButtons';
// Vars

var sb_selectedIndex = -1;
var sb_selectedIndexSaved = -1;
var isNoLockedAction = true;
var pageContents = new Array();

//
// 0 - view mode
// 1 - add mode
// 2 - edit mode
//
var pageInfoMode = PAGE_VIEW_MODE; 

// localized messages:
var MSG_NOTHING_SELECTED_PAGES="";
var MSG_SELECT_ONLY_ONE_PAGE="";
var MSG_PAGE_UPDATED="";
var MSG_PAGE_ADDED="";
var MSG_PAGE_DELETED="";
var MSG_PAGE_NOT_MOVED="";
var MSG_INVALID_PAGESET_TITLE="MSG_INVALID_PAGESET_TITLE";
var MSG_INVALID_PAGE_TITLE="MSG_INVALID_PAGE_TITLE";
var MSG_INVALID_PAGE_CONTENT="MSG_INVALID_PAGE_CONTENT";
var MSG_LIST_EMPTY="";
var DEFAULT_HTML_PAGE_CONTENT="";


// Functions

// ------------
//
//
function sb_setAddMode(defaultTitle,successMessage)
{
	if(!isNoLockedAction) return false;

	var fo = document.forms[0];
	if(null==fo) return;

	var ib = fo.elements[inputPageTitle];
	var sb = fo.elements[selectBoxName];
	if(null==ib || null==sb)return;

	var dt=new Date();
	var pageName = 'page'+dt.getTime()+'.html';
	var pageTitle = defaultTitle;

	sb_selectedIndexSaved = sb_selectedIndex;
	pageInfoMode = PAGE_ADD_MODE;

	for (i=0; i < sb.length; i++)
	{
		sb.options[i].selected = false;
	}

	newIndex = sb.length;
	sb_selectedIndex = newIndex;

	sb.options[newIndex]=new Option( pageTitle, pageName, false, false);
	sb.options[newIndex].selected = true;
	pageContents[pageName]=DEFAULT_HTML_PAGE_CONTENT;

	sb.disabled=true;
	SetStatusMessage(successMessage, 'MB_OK');
	showPIB();

	var cc = fo.elements['sb_changes'];
	if(null!=cc) cc.value=1;

	ib.select();
	ib.focus();
}


// ------------
//
//
function sb_setEditMode(successMessage)
{
	if(!__sb_is_moving_or_edit()) return false;

	var fo = document.forms[0];
	if(null==fo) return false;

	var ib = fo.elements[inputPageTitle];
	var sb = fo.elements[selectBoxName];
	if(null==ib || null==sb)return;

	sb.disabled=true;

	pageInfoMode = PAGE_EDIT_MODE;
	SetStatusMessage(successMessage, 'MB_OK');
	showPIB();

	ib.select();
	ib.focus();
}
// ------------
//
//
function sb_apply_page_info()
{
	if(pageInfoMode!=PAGE_EDIT_MODE && pageInfoMode!=PAGE_ADD_MODE)
	{
		return 1;
	}

	var fo = document.forms[0];
	if(null==fo) return 0;

	var ib = fo.elements[inputPageTitle];
	var ibc = fo.elements[inputPageContent];
	var sb = fo.elements[selectBoxName];
	if(null==ib || null==ibc || null==sb)return 0;

	if(ib.value=='' || sb_checkInvalidSymbols(ib.value))
	{
		alert(MSG_INVALID_PAGE_TITLE);
		return 0;
	}

	var str=ibc.value;
	str = str.replace(/\n/ig, "<br/>");

	var div=document.getElementById("SB_checkValidHTML");

//	&#63; = ? &amp;=& 
	str = str.replace(/\?/ig,"&#63;");
//	str = str.replace(/\&/ig,"&amp;");
	div.innerHTML=str;


	var text=getHTML(div,false);
//	alert(text);
	ibc.value = text;
/*
	if(sb_checkInvalidSymbols(ibc.value))
	{
		alert(MSG_INVALID_PAGE_CONTENT);
		return 0;
	}
*/
	var cc = fo.elements['sb_changes'];
	if(null!=cc) cc.value=1;

	var val = sb.options[sb_selectedIndex].value;
	if(pageInfoMode==PAGE_ADD_MODE)
	{
		if(val.indexOf(";")==-1) sb.options[sb_selectedIndex].text = ib.value;
		else sb.options[sb_selectedIndex].text = '... ' + ib.value;

		pageContents[sb.options[sb_selectedIndex].value]=ibc.value;
		if(sb_selectedIndex!=-1) sb.options[sb_selectedIndex].selected=true;

		SetStatusMessage(MSG_PAGE_ADDED, 'MB_OK');
	}
	else
	//if(pageInfoMode==PAGE_EDIT_MODE)
	{
		if(val.indexOf(";")==-1) sb.options[sb_selectedIndex].text=ib.value;
		else sb.options[sb_selectedIndex].text='... ' + ib.value;

		pageContents[sb.options[sb_selectedIndex].value]=ibc.value;
		if(sb_selectedIndex!=-1) sb.options[sb_selectedIndex].selected=true;
		SetStatusMessage(MSG_PAGE_UPDATED, 'MB_OK');
	}

	pageInfoMode = PAGE_VIEW_MODE;
	sb.disabled=false;
	showPIB();

	return 1;
}
// ------------
//
//
function sb_cancel_change_page_info()
{
	var fo = document.forms[0];
	if(null==fo) return;

	var ib = fo.elements[inputPageTitle];
	var sb = fo.elements[selectBoxName];
	if(null==ib || null==sb)return;

	if(pageInfoMode==PAGE_ADD_MODE)
	{
		pageContents[sb.options[sb_selectedIndex].value]=null;
		sb.options[sb_selectedIndex]=null;

		sb_selectedIndex = sb_selectedIndexSaved;
		if(sb_selectedIndex!=-1) sb.options[sb_selectedIndex].selected=true;
	}

	pageInfoMode = PAGE_VIEW_MODE;
	sb.disabled=false;
	SetStatusMessage('', '', false);
	showPIB();
}
// ------------
// show|hide buttons panel for add|edit page info
//
function showPIB()
{
	visiblePanel = pageInfoMode!=PAGE_VIEW_MODE;
	var el=document.getElementById(pageInfoButtonsPanelID);
	if(null!=el)
	{
		el.style.visibility=visiblePanel?'visible':'hidden';
		el.style.display=visiblePanel?'block':'none';
		isNoLockedAction = !visiblePanel;
	}
	sb_resetPageData();
}

// ------------
//
//
function sb_PageInfoOnFocus(obj){ if(pageInfoMode==PAGE_VIEW_MODE) obj.blur(); }
function sb_PagesListOnFocus(obj){ if(pageInfoMode!=PAGE_VIEW_MODE) obj.blur(); }
// ------------
//
//
function sb_PagesListOnChange(obj)
{
	sb_selectedIndex = obj.selectedIndex;
	sb_resetPageData();
	SetStatusMessage('', '', false);
}
// ------------
//
//
function sb_resetPageData()
{
	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	var ib = fo.elements[inputPageTitle];
	var ibc = fo.elements[inputPageContent];
	if( null==ib || null==ibc || null==sb)return;


	if(sb.length==0) sb_selectedIndex=-1;
	else
	{
		for (i=0; i < sb.length; i++)
		{
			if(sb.options[i].selected)
			{
				sb_selectedIndex = i;
				break;
			}
		}

		if(sb.length > 0 && sb_selectedIndex==-1) 
		{
			sb_selectedIndex = 0;
			sb.options[0].selected = true;
		}
	}

	if(sb_selectedIndex==-1)
	{
		ib.value = '';
		ibc.value = '';
		ib.disabled=true;
		ibc.disabled=true;
	}
	else
	{
		ib.disabled=false;
		ibc.disabled=false;

		var val = sb.options[sb_selectedIndex].value;
		var txt = sb.options[sb_selectedIndex].text;

		if(val.indexOf(";")==-1) ib.value = sb.options[sb_selectedIndex].text;
		else ib.value = txt.substring(4);
		if(pageContents[sb.options[sb_selectedIndex].value])
		{
			var t = pageContents[sb.options[sb_selectedIndex].value];
			var r = /&quot;/g;
			var r2 = /&#39;/g;
			t = t.replace(r, '\"');
			t = t.replace(r2, '\'');
			ibc.value = t;
		}
		else
			ibc.value = DEFAULT_HTML_PAGE_CONTENT;
	}
}
// ------------
//
//
function sb_del_page(confirmMessage)
{
	if(!isNoLockedAction) {return false;}

	var fo = document.forms[0];
	if(null==fo) return false;
	var sb = fo.elements[selectBoxName];
	if(null==sb){return false;}

	if(sb.length==0)
	{
		SetStatusMessage(MSG_NOTHING_SELECTED_PAGES, 'MB_STOP');
		return false;
	}

	var totalDeleted = 0;
	for (i=0; i < sb.length; i++)
	{
		if(sb.options[i].selected)
		{
			totalDeleted += __sb_getTotalChild( sb, i);
			totalDeleted++;
		}
	}

	if(totalDeleted==0)
	{
		SetStatusMessage(MSG_NOTHING_SELECTED_PAGES, 'MB_STOP');
		return false;
	}

	if(!confirm(totalDeleted + confirmMessage)) return false;

	for (i=0; i < sb.length; i++)
	{
		if(sb.options[i].selected)
		{
			var childTotal = __sb_getTotalChild( sb, i);
			if(childTotal)
			{
				// remove owner mark for current node children:
				for(j=0, k=i+1; j < childTotal; j++, k++)
				{
					pageContents[sb.options[k].value]=null;
					sb.options[k]=null;
					/* Fucked netscape java script engine */
					if(sb.options[k]!=null) k = k - 1;
					totalDeleted++;
				}
			}

			pageContents[sb.options[i].value]=null;
			sb.options[i]=null;
			// Fucked netscape java script engine
			if(sb.options[i]!=null) i = i - 1;
			totalDeleted++;
		}
	}

	if(totalDeleted > 0)
	{
		SetStatusMessage(totalDeleted + ' ' + MSG_PAGE_DELETED, 'MB_OK');
		sb_selectedIndex = -1;
		sb_resetPageData();
		var cc = fo.elements['sb_changes'];
		if(null!=cc) cc.value=1;
	}
}
// ------------
//
//
function sb_move_down(successMessage)
{
	if(!__sb_is_moving_or_edit()) return false;

	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb) return;

	var success=false;
	for(i=0; sb.length-1 > i; i++)
	{
		if(sb.options[i].selected)
		{
			var next = sb.options[i+1].value;
			var val = sb.options[i].value;
			var pos = val.indexOf(";");
			if( pos==-1 )
			{
				var childTotal = __sb_getTotalChild( sb, i);
				var nPos = i + childTotal + 1;
				if(nPos==sb.length)
				{
					break;
				}

				var nchildTotal = __sb_getTotalChild( sb, nPos);
				for(k=0; sb.length > k; k++)
				{
					sb.options[k].selected=false;
				}

				sb.options[nPos].selected=true;
				sb_move_up(successMessage);
				for(k=0; sb.length > k; k++)
				{
					if(sb.options[k].value==val)
					{
						sb.options[k].selected = true;
						sb_selectedIndex = k;
						sb_resetPageData();
					}
					else
					{
						sb.options[k].selected = false;
					}
				}
				success =  true;
				break;
			}
			else
			{
				// moving item of second level
				if(next.indexOf(";")==-1) break;

				var txt = sb.options[i].text;
				sb.options[i].value = sb.options[i+1].value;
				sb.options[i].text = sb.options[i+1].text;
				sb.options[i].selected=false;
				sb.options[i+1].value = val;
				sb.options[i+1].text = txt;
				sb.options[i+1].selected=true;
				sb_selectedIndex = i+1;
				sb_resetPageData();
				success =  true;
			}
			break;
		}
	}

	if(success)
	{
		SetStatusMessage(successMessage, 'MB_OK');
		var cc = fo.elements['sb_changes'];
		if(null!=cc) cc.value=1;
	}
	else SetStatusMessage(MSG_PAGE_NOT_MOVED, 'MB_STOP');
}
// ------------
//
//
function __sb_is_moving_or_edit()
{
	if(!isNoLockedAction) return false;

	var fo = document.forms[0];
	if(null==fo) return false;
	var sb = fo.elements[selectBoxName];
	if(null==sb) return false;

	if(sb.length==0)
	{
		SetStatusMessage(MSG_LIST_EMPTY, 'MB_STOP');
		return false;
	}
	var totalSelected = 0;
	for (i=0; i < sb.length; i++)
	{
		if(sb.options[i].selected) totalSelected++;
		
	}

	if(totalSelected == 0)
	{
		SetStatusMessage(MSG_NOTHING_SELECTED_PAGES, 'MB_STOP');
		return false;
	}

	if(totalSelected > 1)
	{
		SetStatusMessage(MSG_SELECT_ONLY_ONE_PAGE, 'MB_STOP');
		return false;
	}

	return true;
}
// ------------
//
//
function __sb_getTotalChild( sb, ownerPosition)
{
	var count = 0;
	if(sb)
	{
		for(c=ownerPosition+1; c < sb.length; c++)
		{
			var nval = sb.options[c].value;
			if(nval.indexOf(";")==-1) break;
			count++;
		}
	}
	return count;
}


function sb_move_up(successMessage)
{
	if(!__sb_is_moving_or_edit()) return false;

	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb)return;

	var success = false;
	for(i=1; sb.length > i; i++)
	{
		if(sb.options[i].selected)
		{
			var val = sb.options[i].value;
			var prev = sb.options[i-1].value;
			var pos = val.indexOf(";");
			var pPos = prev.indexOf(";");

			if( pos==-1 )
			{
				// moving item of first level
				if(pPos==-1)
				{
					var ccount = __sb_getTotalChild( sb, i);
					var steps = ccount+1;

					for(j=0, m=i; j < steps; j++, m++)
					{
						var jval =  sb.options[m].value;
						var jtxt =  sb.options[m].text;
						var jsel =  sb.options[m].selected;

						sb.options[m].value = sb.options[m-1].value;
						sb.options[m].text = sb.options[m-1].text;
						sb.options[m].selected=sb.options[m-1].selected;
						sb.options[m-1].value = jval;
						sb.options[m-1].text = jtxt;
						sb.options[m-1].selected=jsel;
					}

					success = true;
					break;
				}
				else
				{
					prevVal = prev.substring(0, pPos);
					var count = 0;
					for(p=i-1; p >= 0; p=p-1)
					{
						count++;
						if(sb.options[p].value==prevVal) break;
					}

					var ccount = __sb_getTotalChild( sb, i);
					var steps=ccount+1;
					for(k=0; k < steps; k++, i++)
					{
						for(j=0, m=i; j < count; j++, m=m - 1)
						{
							var jval =  sb.options[m].value;
							var jtxt =  sb.options[m].text;
							var jsel =  sb.options[m].selected;

							sb.options[m].value = sb.options[m-1].value;
							sb.options[m].text = sb.options[m-1].text;
							sb.options[m].selected=sb.options[m-1].selected;
							sb.options[m-1].value = jval;
							sb.options[m-1].text = jtxt;
							sb.options[m-1].selected=jsel;
						}
					}

					success = true;
					break;
				}
			}
			else
			{
				// moving item of second level
				if(prev.indexOf(";")!=-1)
				{
					var txt = sb.options[i].text;
					sb.options[i].value = sb.options[i-1].value;
					sb.options[i].text = sb.options[i-1].text;
					sb.options[i].selected=false;
					sb.options[i-1].value = val;
					sb.options[i-1].text = txt;
					sb.options[i-1].selected=true;
					sb_selectedIndex = i-1;
					sb_resetPageData();
					success = true;
				}
			}
			
			break;
		}
	}

	if(success) SetStatusMessage(successMessage, 'MB_OK');
	else SetStatusMessage(MSG_PAGE_NOT_MOVED, 'MB_STOP');
}


function sb_checkInvalidSymbols(value)
{
	var regexp = /[\'|\"|\&|\\|<|>]/;
	return regexp.test(value);
}


function sb_lover_level(successMessage)
{
	if(!__sb_is_moving_or_edit()) return false;

	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb)return;

	var success = false;
	for(i=1; sb.length > i; i++)
	{
		if(sb.options[i].selected)
		{
			var val = sb.options[i].value;
			if(val.indexOf(";")==-1)
			{
				var pVal = sb.options[i-1].value;
				var pPos = pVal.indexOf(";");
				if(pPos > -1) pVal = pVal.substring(0, pPos);

				// set new value:

				var content = pageContents[sb.options[i].value];
				pageContents[sb.options[i].value] = null;

				sb.options[i].value = pVal+';'+val;
				sb.options[i].text = '... '+sb.options[i].text;
				pageContents[sb.options[i].value] = content;
				sb_selected_index = i;

				// set new owner for current node children:
				for(k=i+1; sb.length > k; k++)
				{
					var kval = sb.options[k].value;
					var kpos = kval.indexOf(";");
					if(kpos==-1) break;

					var content = pageContents[sb.options[k].value];
					pageContents[sb.options[k].value] = null;

					//set new parent:
					sb.options[k].value = pVal+';'+kval.substring(kpos+1);
					pageContents[sb.options[k].value] = content;
				}
				sb.options[sb_selected_index].selected = true;
				SetStatusMessage(successMessage, 'MB_OK');
				break;
			}
			else
			{
				SetStatusMessage(MSG_PAGE_NOT_MOVED, 'MB_STOP');
				break;
			}
		}
	}
}

function sb_upper_level(successMessage)
{
	if(!__sb_is_moving_or_edit()) return false;

	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb)return;

	for(i=1; sb.length > i; i++)
	{
		if(sb.options[i].selected)
		{
			var val = sb.options[i].value;
			var pos = val.indexOf(";");
			if(pos==-1)
			{
				SetStatusMessage(MSG_PAGE_NOT_MOVED, 'MB_STOP');
				break;
			}
			else
			{
				var txt = sb.options[i].text;
				var content = pageContents[sb.options[i].value];
				pageContents[sb.options[i].value] = null;

				// set new value:
				sb.options[i].value = val.substring(pos+1);
				sb.options[i].text = txt.substring(4);
				pageContents[sb.options[i].value] = content;
				sb_selected_index = i;

				var pVal = sb.options[i].value;

				// set new owner for current node children:
				for(k=i+1; sb.length > k; k++)
				{
					var kval = sb.options[k].value;
					var kpos = kval.indexOf(";");
					if(kpos==-1) break;

					var content = pageContents[kval];
					pageContents[kval] = null;

					//set new parent:
					sb.options[k].value = pVal+';'+kval.substring(kpos+1);
					pageContents[sb.options[k].value] = content;
				}

				sb.options[sb_selected_index].selected = true;
				SetStatusMessage(successMessage, 'MB_OK');
				break;
			}
		}
	}
}


// Mark all selectbox's items 
// before sending of the given form
function sb_selectAll()
{
	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb)return;
	if(sb.length==0) return;

	for(i=0; sb.length > i; i++)
	{
		sb.options[i].selected=true;
	}
}

// Mark all selectbox's items 
// before sending of the given form
function sb_beforeSubmit()
{
	if(!isNoLockedAction) return 0;
	var fo = document.forms[0];
	var el=document.getElementById('SB_PAGESET_FORM_DIV_HIDDENS');
	if(null==el || null==fo) return 0;

	var ibps = fo.elements[inputPageSetTitle];
	var sb = fo.elements[selectBoxName];
	if(null==sb || null==ibps)return 0;

	if(sb.length==0)
	{
		SetStatusMessage(MSG_LIST_EMPTY, 'MB_STOP');
		return 0;
	}


	if(ibps.value=='' || sb_checkInvalidSymbols(ibps.value))
	{
		alert(MSG_INVALID_PAGESET_TITLE);
		return 0;
	}

	var buffer = '';
	for(i=0; sb.length > i; i++)
	{
		sb.options[i].selected=true;

		var val = sb.options[i].value;
		var txt = sb.options[i].text;

		buffer += '<input type="hidden" name="sb_content_for_page_'+i+'"'
//		+' value="'+(pageContents[sb.options[i].value]? pageContents[sb.options[i].value] : '')
// TODO		+' value="'+escape((pageContents[sb.options[i].value]? pageContents[sb.options[i].value] : ''))
+' value="'+pagesets_encode_str((pageContents[sb.options[i].value]? pageContents[sb.options[i].value] : ''))
		+'"/>\n<input type="hidden" name="sb_title_for_page_'+i+'"'
		+' value="'+pagesets_encode_str(((val.indexOf(";")==-1)? sb.options[i].text : txt.substring(4)))+'"/>\n';
// TODO:		+' value="'+escape(((val.indexOf(";")==-1)? sb.options[i].text : txt.substring(4)))+'"/>\n';
	}

	el.innerHTML = buffer;

	// disabled not submit data:
	var ib = fo.elements[inputPageTitle];
	var ibc = fo.elements[inputPageContent];
	if(null!=ib) ib.disabled=true;
	if(null!=ibc) ibc.disabled=true;

	return 1;
}


function pagesets_encode_str(str)
{
	try
	{
			str = str.replace(/&/ig, "&amp;");
			//str = str.replace(/&amp;/ig, "&amp;");
		
		while(str.match(/\?/ig) != null)
		{
			str = str.replace(/\?/ig,"&#63;");
		}
		while(str.match(/</ig) != null)
		{
			str=str.replace(/</ig,'&lt;');
		}
		while(str.match(/>/ig) != null)
		{
			str=str.replace(/>/ig,'&gt;');
		}
		while(str.match(/\'/ig) != null)
		{
			str=str.replace(/\'/ig,"&#39;");
		}
		while(str.match(/\"/ig) != null)
		{
			str=str.replace(/\"/ig,"&#34;");
		}
	}
	catch(e){ }

	return str;
}

function validate()
{
	if(!sb_apply_page_info()) return 0;
	return sb_beforeSubmit();
}



htmlEncode = function(str) {
	try
	{
		
			str = str.replace(/&/ig, "&amp;");
			//str = str.replace(/&amp;/ig, "&amp;");
		
		while(str.match(/\?/ig) != null)
		{
			str = str.replace(/\?/ig,"&#63;");
		}
		while(str.match(/</ig) != null)
		{
			str=str.replace(/</ig,'&lt;');
		}
		while(str.match(/>/ig) != null)
		{
			str=str.replace(/>/ig,'&gt;');
		}
		while(str.match(/\'/ig) != null)
		{
			str=str.replace(/\'/ig,"&#39;");
		}
		while(str.match(/\"/ig) != null)
		{
			str=str.replace(/\"/ig,"&#34;");
		}
	}
	catch(e){ }
	return str;
};
needsClosingTag = function(el) {
	var closingTags = " script style div span tr td tbody table em strong font a ";
	return (closingTags.indexOf(" " + el.tagName.toLowerCase() + " ") != -1);
};

getHTML = function(root, outputRoot) {
	var html = "";
	
	switch (root.nodeType) {
	    case 1: // Node.ELEMENT_NODE
	    case 11: // Node.DOCUMENT_FRAGMENT_NODE
		var closed;
		var i;
		if (outputRoot) {
			closed = (!(root.hasChildNodes() || needsClosingTag(root)));
			html = "<" + htmlEncode( root.tagName.toLowerCase() );
			
			var attrs = root.attributes;
			for (i = 0; i < attrs.length; ++i) {
				var a = attrs.item(i);
				if (!a.specified) {
					continue;
				}
				var name = a.nodeName.toLowerCase();
				if (/_moz/.test(name)) {
					// Mozilla reports some special tags
					// here; we don't need them.
					continue;
				}
				var value;
				if (name != "style") {
					try{
					if (typeof root[a.nodeName] != "undefined") {
						value = root[a.nodeName];
					} else {
						value = a.nodeValue;
					}
					}catch(e){
						value = a.nodeValue;
					}
				} else { 
					value = root.style.cssText;
				}
				if (/_moz/.test(value)) {
					continue;
				}
//				html += " " + name + '="' + value + '"';
				if(/[^a-z]/.test(name) || value=="")
				{

				}
				else
				{
					html += " " + name + '="' + value + '"'; 
				}
			}
			
			
				html += closed ? " />" : ">";
			
		}
		for (i = root.firstChild; i; i = i.nextSibling) {
			html += getHTML(i, true);
		}
		if (outputRoot && !closed) {
			html += "</" + root.tagName.toLowerCase() + ">";
		}
		break;
	    case 3: // Node.TEXT_NODE
		html = htmlEncode(root.data);
		break;
	    case 8: // Node.COMMENT_NODE
		html = "<!--" + root.data + "-->";
		break;		// skip comments, for now.
		
	}
	return html;
};

/*


function show()
{
	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb)return;
	var str = '';
	for(i=0; sb.length > i; i++)
	{
		str += '\n' + sb.options[i].text + ' : ' + sb.options[i].value;
	}

	fo.elements['sb_page_content'].value = str;
}

//
// show|hide dialog import language
//
function showIL( visibleDialog )
{
	var el=document.getElementById('SB_Style_importLanguage');
	if(null!=el)
	{
		el.style.visibility=visibleDialog?'visible':'hidden';
		el.style.display=visibleDialog?'block':'none';
	}
}

// ------------
// show|hide dialog "input new page"
//

var inputNewPageTitle = 'sb_new_page_title';

function showINP( visibleDialog )
{
	var el=document.getElementById(inputNewPageBoxID);
	if(null!=el)
	{
		el.style.visibility=visibleDialog?'visible':'hidden';
		el.style.display=visibleDialog?'block':'none';
		var fo = document.forms[0];
		if(fo)
		{
			var ib = fo.elements[inputPageTitle];
			var inb = fo.elements[inputNewPageTitle];
			var ibc = fo.elements[inputPageContent];
			var ibps = fo.elements[inputPageSetTitle];
			var sb = fo.elements[selectBoxName];

			if( ib && inb && ibc && ibps && sb)
			{
				ib.disabled=visibleDialog;
				ibc.disabled=visibleDialog;
				ibps.disabled=visibleDialog;
				sb.disabled=visibleDialog;
				inb.disabled=!visibleDialog;
				if(visibleDialog)
				{
					inb.select();
					inb.focus();
					isNoLockedAction = false;
				}
				else
				{
					isNoLockedAction = true;
				}
			}
		}
	}
}

function sb_PageTitleOnChange(obj)
{
	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb || sb.length==0)return;

	var val = sb.options[sb_selectedIndex].value;
	if(val.indexOf(";")==-1) sb.options[sb_selectedIndex].text = obj.value;
	else sb.options[sb_selectedIndex].text = '... ' + obj.value;
}

function sb_PageContentOnChange(obj)
{
	var fo = document.forms[0];
	if(null==fo) return;
	var sb = fo.elements[selectBoxName];
	if(null==sb || sb.length==0)return;

	pageContents[sb.options[sb_selectedIndex].value] = obj.value;
}
*/