<?
include_once('class.errHandler.php');
include_once('messages.php');
include_once('constants.php3');
require_once('common_func.php3');
include_once('class.Session.php');
include_once('key/Key.php');



// detect VE before db_connect();
// detect Plesk 8.1 and require cu.php instead

$prod_version = explode ('-', PRODUCT_VERSION);
if (version_compare($prod_version[1], '8.1','<'))
	require_once('api-common/class.cu.php');
else
	require_once('api-common/cu.php');

cu::initCLI();

$psa_is_configured = get_param('psa_configured');
if (!$psa_is_configured || ($psa_is_configured != 'true')) {
        cu::print_stderr('Plesk is not configured. You should go to the control panel for postinstall server configuration.');
        cu::cuExit(1);
}


class sbm_hosting_updater extends cu
{
		var	$allowed_commands = array(

		array(	CU_OPT_LONG		=> 'add',
				CU_OPT_SHORT	=> 'a',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Create site and/or reseller for domain. Use -type all for reseller & site creation'),

		array(	CU_OPT_LONG		=> 'update',
				CU_OPT_SHORT	=> 'u',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Update sites & resellers for domain/subdomain.'),

		array (	CU_OPT_LONG		=> 'remove',
				CU_OPT_SHORT	=> 'r',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Remove sites & resellers for domain/subdomain.'),

		array (	CU_OPT_LONG		=> 'help',
				CU_OPT_SHORT	=> 'h',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Help page'),

		array (	CU_OPT_LONG		=> 'module-clean',
				CU_OPT_SHORT	=> 'C',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Cleaning reseller\'s custom buttons'),

	);

	var $allowed_options = array(

		array(	CU_OPT_LONG			=> 'type',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '< domain | subdomain | reseller>',
				CU_OPT_DESC			=> 'Hosting type.'),

		array(	CU_OPT_LONG			=> 'name',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<domain-name>',
				CU_OPT_DESC			=> 'New domain name'),
//				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_SUBDOMAIN),

		array(	CU_OPT_LONG			=> 'domain-name',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<domain-name>',
				CU_OPT_DESC			=> 'Domain name for subdomain.',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_DOMAIN),
	);

	function execute()
	{
		$cmds = parent::getCommand();
		if ($this->error() || is_null($cmds))
			return false;

		$keys = array_keys($cmds);
		$cmd = array_shift($keys);

		switch ($cmd) {

			case 'help':
				$this->printHelp();
				break;

			case 'man':
				$this->_printMan();
				break;

			case 'add':
				/* some options are required for creation */
				$this->setRequiredOptions(array('type', 'name'));
				$opts = parent::getOptions();
				if ($this->error())
					return false;

				if ($opts['type'] == 'reseller' || $opts['type'] == 'all'){
					if ($this->send_reseller_data('allow')){
						cu::print_stdout("Reseller for '".$opts['name']."' has been successfully added\n");
					}
				}
				if (in_array($opts['type'], array('domain','subdomain', 'all'))){
					if ($this->send_site_data('allow')){
						cu::print_stdout("Site for '".$opts['name']."' has been successfully added\n");
	//					cu::print_stdout('Status: ' . $stat_msg . ' '."\n");
					}
				}
				break;

			case 'update':
				/* some options are required for creation */
				$this->setRequiredOptions(array('type', 'name'));
				if ($this->error())
					return false;

				if ($this->update_reseller_data())
					cu::print_stdout('===> Resellers successfully updated' . "\n");
				if ($this->update_site_data())
					cu::print_stdout('===> Sites successfully updated' . "\n");
				break;

			case 'remove':
				/* some options are required for creation */
				$this->setRequiredOptions(array('type', 'name'));
				if ($this->error())
					return false;

				if ($opts['type'] == 'reseller' || $opts['type'] == 'all'){
					if ($this->send_reseller_data('deny')){
						cu::print_stdout("Reseller for '".$opts['name']."' has been removed successfully\n");
					}
				}
				if (in_array($opts['type'], array('domain','subdomain', 'all'))){
					if ($this->send_site_data('deny')){
						cu::print_stdout("Site for '".$opts['name']."' has been removed successfully\n");
//						cu::print_stdout('Status: ' . $stat_msg . ' '."\n");
					}
				}

				
				break;
			
			case 'module-clean':
				$this->clean_module_data();
				break;
				
			default:
				return $this->setError_('Unknown command: "' . $cmd . '"');
		}

		return true;
	}
	
	function update_reseller_data()
	{
		$opts = parent::getOptions();
		if (is_null($opts))
			return false;
			
		global $server;
		global $GLOBALS;
		$GLOBALS['server'] = $server;
		require_once('modules/sbm3/ra_api.php');
		require_once('modules/sbm3/RA_psa_resellers.php');
		require_once('modules/sbm3/class.sbmDomain.php');
		if ($opts["type"] == "domain" && $domain_id = cu::get_domain_id_by_name($opts['name'])){
			if ($reseller_login = get_reseller_sb_login($domain_id)){
				$domain = new sbm_Domain($domain_id);
				$reseller = new RA_Resellers();
				$par = &$reseller->data[$reseller_login];
				$par['DOMAIN'] = $domain->getHostname();
				$par['EMAIL'] = 'please@specify.email';
				$par['NAME'] = "PSAReseller";
				$par['LANGUAGE'] = "en_US";
				$par['SKIN']	=	"default";
				$par['LOGIN']	=	$domain->getFtpLogin()."@".$domain->getHostname();
				$par['PSWD'] = $domain->getFtpPasswd();
				$par['PSWD_CONF'] = $domain->getFtpPasswd();
				$par['HOSTS'] = array($domain->getIPAddress() => $reseller_login);
				$par['LIMIT_SITES'] = get_sites_limit($domain->getID());
				$par['LIMIT_HOSTS'] = 1;
				
				$reseller->update($reseller_login);
	
				if ($reseller->error()){
					$cmd = check_result($reseller->error());
					if ($cmd == 0 || $cmd == 1){
						cu::print_stdout('Error:' .  $reseller->error['MESSAGE'].". \n");
						var_dump($reseller);
						return false;
					}
				}
				$url = '/modules/sbm3/index.php?sb_server='.$domain->sb_server['name'].'&ra_cmd=main&pswd';
				cb_clean($domain->getID(), $url);
				$prefix = (isset($_SERVER['HTTP_HOST'])) ? "https://".$_SERVER["HTTP_HOST"] : "https://".get_param('FullHostName').":8443";
				$url = $prefix."/modules/sbm3/index.php?sb_server=".$domain->sb_server['name'].'&ra_cmd=main&ftp_user='.$domain->getFtpLogin()."@".$domain->getHostname().'&ftp_pass='.$domain->getFtpPasswd();
				sbm_create_button($domain->getID(), $url);
				$query = 'UPDATE `'.RA_TBL_RESELLERS.'` SET `domain_id` = \''.$domain->getID().'\', `sb_server_id` = \''.$domain->sb_server['id'].'\''.", `sb_login` = '".$domain->getFtpLogin()."@".$domain->getHostname()."' WHERE `id` = '".get_reseller_id($domain_id)."';";
				db_query($query);
//				Update site owners
				$query = 'UPDATE `'.RA_TBL_DOMAINS."` SET `site_owner` = '".$domain->getFtpLogin()."@".$domain->getHostname()."' WHERE `site_owner` = '$reseller_login' AND `sb_server_id` = '".$domain->sb_server['id']."';";
				db_query($query);
				return true;
			}
		}
		return false;
	}
	
	function update_site_data(){
		$opts = parent::getOptions();
		if (is_null($opts))
			return false;
			
		global $stat_msg;
		global $server;
		require_once('modules/sbm3/ra_api.php');
		require_once('modules/sbm3/RA_domains.php');
		require_once('modules/sbm3/class.sbmDomain.php');
	
		if ($opts["type"] == "domain" && $domain_id = cu::get_domain_id_by_name($opts['name'])){
			$domain = new sbm_Domain($domain_id);
		} elseif (
			$opts["type"] == "subdomain" && 
			$opts['domain-name'] != "" && 
			$subdom_id = cu::get_subdomain_id_by_name($opts['name'], $opts['domain-name'])){
				$domain = new sbm_SubDomain($subdom_id);
				if (!is_object($domain))
					return false;
				
				$work_dir = ($domain->getUserType() == 'main')?'subdomains/'.$domain->subdomain_name.'/httpdocs':'httpdocs';
				$domain->setWorkDir($work_dir);
		}
		if (isset($domain)){
			$resellers = $domain->getAttribute('site_owners');
			$old_server = $server;
			foreach ($resellers as $owner => $site_id){
				if (is_allowed_reseller($owner)){
					if ($owner != sbm_get_root_login()){
						$server ['username'] = $owner;
						$server ['password'] = $domain->getFtpPasswd();
						$domain->sb_server = $server;
						$domain->fetchDetails();
					} 
					$this->send_site_update_data($domain);
					$server = $old_server;
				}
			}
			return true;
		} else {
			cu::print_stdout('Domain/subdomain not found' . "\n");
			return false;
		}
	}
	
	function send_site_update_data($domain = NULL)
	{

		if (is_null($domain) || !$domain->isAllowed()) 
			return false;
		$params = array (
			'sb_old_siteid' => $domain->getSiteID(),
			'sb_server_user'=> $domain->sb_server['username'],
			'site_id' 		=> $domain->getSiteAlias(),
			'ip_address'	=> $domain->getIPAddress(),
			'domain_name'	=> $domain->getHostname(),
			'ftp_login' 	=> $domain->getFtpLogin(),
			'ftp_password'	=> $domain->getFtpPasswd(),
			'work_dir'		=> $domain->getWorkDir(),
			'reseller'		=> $domain->sb_server['username'],
			);
		if ($result = add_sb_site($params, 'update_site')){
			$site_id = $result->result->get_content();
			if ($site_id != ""){
				if (get_class($domain) == "sbm_Domain") { //Add custom buttons only for domains
					$url = "/modules/sbm3/open_sb.php?sb_server=".substr($domain->sb_server['name'], 0, strpos($domain->sb_server['name'],'remote_admin/')).'&siteid='.$site_id."&pswd=".$domain->getFtpPasswd();
					cb_clean($domain->getID(), $url);
					$prefix = (isset($_SERVER['HTTP_HOST'])) ? "https://".$_SERVER["HTTP_HOST"]."/" : "https://".get_param('FullHostName').":8443";
					cb_icon_create($domain->getId(),  $prefix.$url, $domain->sb_server['username']);
				}
				$domain->setAttribute("site_owners", array($domain->sb_server['username'] => $site_id));
				$domain->add_tbl_record($domain->sb_server['username']);
				return true;
			}
		}
		return false;
	}
	
	function send_reseller_data($command = null)
	{
		$opts = parent::getOptions();
		if (is_null($opts) || !in_array($command, array('allow','deny')))
			return false;
			
		global $stat_msg;
		require_once('modules/sbm3/ra_api.php');
		require_once('modules/sbm3/RA_psa_resellers.php');
		$opts["type"] = ($opts["type"] == "all") ? "reseller" : $opts["type"];
		if ($opts["type"] == "reseller" && $domain_id = cu::get_domain_id_by_name($opts['name'])) {
			$func = "resellers_${command}_access";
			$func($domain_id);
		} else {
			cu::print_stdout('Domain/subdomain not found' . "\n");
			return false;
		}
		return true;
	}
	
	function send_site_data($command = null){
		
		$opts = parent::getOptions();
		if (is_null($opts) || !in_array($command, array('allow','deny')))
			return false;
			
		global $server;
		require_once('modules/sbm3/ra_api.php');
		require_once('modules/sbm3/RA_domains.php');
		require_once('modules/sbm3/class.sbmDomain.php');
		
		$func = "return";
		//Adding domain by default
		$opts["type"] = ($opts["type"] == "all") ? "domain" : $opts["type"];
		
		if ($opts["type"] == "domain" && $domain_id = cu::get_domain_id_by_name($opts['name'])) {
			$domain = new sbm_Domain($domain_id);
			$func = "domains_${command}_access";
		} elseif (
			$opts["type"] == "subdomain" && 
			$opts['domain-name'] != "" && 
			$domain_id = cu::get_subdomain_id_by_name($opts['name'], $opts['domain-name'])){
				$domain = new sbm_SubDomain($domain_id);
				$func = "subdomains_${command}_access";
		}
		if (isset($domain)){
			if ($command == 'deny'){ //Delete all sites recursive
				$resellers = $domain->getAttribute('site_owners');
				$old_server = $server;
				foreach ($resellers as $owner => $site_id){
					if (is_allowed_reseller($owner)){
						if ($owner != sbm_get_root_login()){
							$server ['username'] = $owner;
							$server ['password'] = $domain->getFtpPasswd();
							$domain->sb_server = $server;
							$domain->fetchDetails();
						} 
					$func($domain_id);
					$server = $old_server;
					}
				}
			} else {
					$func($domain_id);
			}
		} else {
			cu::print_stdout('Domain/subdomain not found' . "\n");
			return false;
		}
		return true;
	}
	
	function clean_module_data()
	{	
		//Getting all domains 'enabled' in sbm3
		if ($this->sbm3_is_activated_domains()){
			$file_src = PRODUCT_ROOT."/admin/htdocs/modules/".MODULE_NAME."/open_sb.php";
			$file_backuped = PRODUCT_TMP_D."/sbm3_open_sb.php.backup";
			if (!copy($file_src, $file_backuped))
				cu::print_stdout("Can't copy $file_src to $file_backuped:"."\n");
			else 
				cu::print_stdout("File $file_src successfully copied to $file_backuped"."\n");
				
			$query = "SELECT `id` FROM `custom_buttons` where `url` like '%/modules/".MODULE_NAME."/index.php%'";
			$res = db_query($query);
			while (list($cb_id) = mysql_fetch_row($res)){
				$this->clean_cb($cb_id);
			}
		} else 
			$this->clean_all_cb();

		return true;
	}
	
	function clean_cb($cb_id = NULL)
	{
		if (is_null($cb_id))
			return;
			
		require_once('modules/pm.php');
		if (!class_exists('pm_CustomButton')) {
			require_once('class.CustomButton.php');
			$myCustomButton = objectMaker('CustomButton', $cb_id);
		} else {
			$myCustomButton = objectMaker('pm_CustomButton',$cb_id);
		}

		$myCustomButton->delete();

		if ($myCustomButton->error()){
			cu::print_stdout("Can't delete custom butoon:".$myCustomButton->error());
		}
		
	}
	
	function clean_all_cb()
	{
		$query = "SELECT `id` FROM `custom_buttons` where `url` like '%/modules/".MODULE_NAME."/index.php%'";
		$res = db_query($query);
		while (list($cb_id) = mysql_fetch_row($res)){
			$this->clean_cb($cb_id);
		}
		return true;
	}
	
	function sbm3_is_activated_domains()
	{
		$query = 'SELECT COUNT(`domain_id`) FROM '.RA_TBL_DOMAINS;
		return (sbm_string_query($query) > 0);
	}
}


define ('MODULE_NAME',"sbm3");

include_once("modules/sbm3/common.php");
require_once('modules/sbm3/ra_api.php');
require_once('modules/sbm3/RA_domains.php');
require_once('modules/sbm3/config.php');

global $server;
$server = sbm_get_current_server();

$sa = new sbm_hosting_updater();
if ($sa->error()) {
	cu::print_stderr($sa->getErrorMsg());
	cu::cuExit(1);
}

$sa->execute();
if ($sa->error()) {
    cu::print_stderr($sa->getErrorMsg());
    cu::cuExit(1);
}

cu::cuExit(0);

?>
